using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;

/// <summary>
/// Tehtävä 6.
/// </summary>
public class T6_PoistaJonot
{
    /// <summary>
    /// 
    /// </summary>
    public static void Main()
    {
        List<string> jonot = new List<string>();
        jonot.Add("a"); jonot.Add("bb"); jonot.Add("a");
        jonot.Add("antti"); jonot.Add("antt"); jonot.Add("antti");
        Console.WriteLine($"{string.Join(", ", jonot)}");

        // Tapa 1
        PoistaJonot(jonot, "antti");

        // Tapa 2         
        PoistaJonot2(jonot, "a");

        // Tapa 3
        while (jonot.Remove("antt"));
        
        // Tapa 4: Advanced-tekniikka lambda-lausekkeella (ohi kurssin asiaa)
        /* jonot.RemoveAll(x => x == "a"); */
        
        Console.WriteLine("\nNyt lista sisältää seuraavat jonot:\n");
        Console.WriteLine($"{string.Join(", ", jonot)}");
    }
    
    /// <summary>
    /// Poista listasta kaikki toisen parametrin mukaiset sanat.
    /// </summary>
    /// <param name="jonot">Jonot</param>
    /// <param name="poistettava">Poistettava</param>
    public static void PoistaJonot(List<string> jonot, string poistettava)
    {
        int i = 0;
        while (i < jonot.Count)
        {
            if (jonot[i] == poistettava) jonot.RemoveAt(i);
            else i++;
        }
    }
    
    /// <summary>
    /// Poista listasta kaikki toisen parametrin mukaiset sanat.
    /// </summary>
    /// <param name="jonot">Jonot</param>
    /// <param name="poistettava">Poistettava</param>
    public static void PoistaJonot2(List<string> jonot, string poistettava)
    {
        int i = 0;
        while (i < jonot.Count)
        {
            if (jonot[i] == poistettava) jonot.RemoveAt(i);
            else i++;
        }
    }
}